#ifndef __IUF_STARS
#define __IUF_STARS

#ifdef _WIN32
#define drand48() (((float) rand())/((float) RAND_MAX))
#define srand48(x) (srand((x)))
#endif

/** This class represent the starred background.
The starred background is a unitary square filled with stars.
Version History {\small 
\begin{itemize}
\item 0.4 First Release 
\end{itemize}
}
*/

class Stars : public GameObj
{
public:
	vector<Point3f> S;
	vector<Point3f> C;
	int cc;
	/// default constructor 
	Stars(int starn=200){
		cc=0;
		S.resize(starn);
		C.resize(starn+5);
		for(int i=0;i<starn;++i)
		{
			S[i].v[0]=(drand48()-.5);
			S[i].v[1]=(drand48()-.5);
			S[i].v[2]=-10;
		}
		for(i=0;i<starn+5;++i)
		{
			C[i].v[0]=C[i].v[1]=C[i].v[2]=.2+drand48();
		}

	}

	
/** It draws all the stars.
Stars and color are kept in two vector and drawn with glDrawArray().
*/
int Draw()
	{
		glDisable(GL_LIGHTING);
		glColor3f(1.0,1.0,1.0);
		glEnableClientState (GL_VERTEX_ARRAY);
		glEnableClientState (GL_COLOR_ARRAY);
		glVertexPointer(3,GL_FLOAT,0,S.begin());
		glColorPointer(3,GL_FLOAT,0,&(C[cc]));
		glDrawArrays(GL_POINTS,0,S.size());
		glDisableClientState (GL_VERTEX_ARRAY);
		glDisableClientState (GL_COLOR_ARRAY);
		glEnable(GL_LIGHTING);
		return S.size();
	};


	/** Update the color counter.
	Every 1/3 sec the color vector is shifted of one position.
  In this way all the stars change their color.
  */
	void Update(int t)
	{
		static int tt;
		tt+=t;
		if(tt>300)
		{
			tt-=300;
			cc=(cc+1)%5;
		}
	}
	
	};

#endif